#ifndef _SYNTHPOD_STAT_H
#define _SYNTHPOD_STAT_H

typedef enum _stat_urid_t {
	STAT_URID_INVALID = 0,

	RDFS__label,
	RDFS__comment,
	RDFS__range,
	RDFS__subClassOf,
	RDFS__seeAlso,

	RDF__type,
	RDF__value,

	DOAP__description,
	DOAP__license,
	DOAP__name,
	DOAP__shortdesc,

	XSD__int,
	XSD__nonNegativeInteger,
	XSD__long,
	XSD__float,
	XSD__double,

	ATOM__Atom,
	ATOM__AtomPort,
	ATOM__Blank,
	ATOM__Bool,
	ATOM__Chunk,
	ATOM__Double,
	ATOM__Event,
	ATOM__Float,
	ATOM__Int,
	ATOM__Literal,
	ATOM__Long,
	ATOM__Number,
	ATOM__Object,
	ATOM__Path,
	ATOM__Property,
	ATOM__Resource,
	ATOM__Sequence,
	ATOM__Sound,
	ATOM__String,
	ATOM__Tuple,
	ATOM__URI,
	ATOM__URID,
	ATOM__Vector,
	ATOM__atomTransfer,
	ATOM__beatTime,
	ATOM__bufferType,
	ATOM__childType,
	ATOM__eventTransfer,
	ATOM__frameTime,
	ATOM__supports,
	ATOM__timeUnit,

	BUF_SIZE__boundedBlockLength,
	BUF_SIZE__coarseBlockLength,
	BUF_SIZE__fixedBlockLength,
	BUF_SIZE__maxBlockLength,
	BUF_SIZE__minBlockLength,
	BUF_SIZE__nominalBlockLength,
	BUF_SIZE__powerOf2BlockLength,
	BUF_SIZE__sequenceSize,

	CORE__AllpassPlugin,
	CORE__AmplifierPlugin,
	CORE__AnalyserPlugin,
	CORE__AudioPort,
	CORE__BandpassPlugin,
	CORE__CVPort,
	CORE__ChorusPlugin,
	CORE__CombPlugin,
	CORE__CompressorPlugin,
	CORE__ConstantPlugin,
	CORE__ControlPort,
	CORE__ConverterPlugin,
	CORE__DelayPlugin,
	CORE__DistortionPlugin,
	CORE__DynamicsPlugin,
	CORE__EQPlugin,
	CORE__EnvelopePlugin,
	CORE__ExpanderPlugin,
	CORE__ExtensionData,
	CORE__Feature,
	CORE__FilterPlugin,
	CORE__FlangerPlugin,
	CORE__FunctionPlugin,
	CORE__GatePlugin,
	CORE__GeneratorPlugin,
	CORE__HighpassPlugin,
	CORE__InputPort,
	CORE__InstrumentPlugin,
	CORE__LimiterPlugin,
	CORE__LowpassPlugin,
	CORE__MixerPlugin,
	CORE__ModulatorPlugin,
	CORE__MultiEQPlugin,
	CORE__OscillatorPlugin,
	CORE__OutputPort,
	CORE__ParaEQPlugin,
	CORE__PhaserPlugin,
	CORE__PitchPlugin,
	CORE__Plugin,
	CORE__PluginBase,
	CORE__Point,
	CORE__Port,
	CORE__PortProperty,
	CORE__Resource,
	CORE__ReverbPlugin,
	CORE__ScalePoint,
	CORE__SimulatorPlugin,
	CORE__SpatialPlugin,
	CORE__Specification,
	CORE__SpectralPlugin,
	CORE__UtilityPlugin,
	CORE__WaveshaperPlugin,
	CORE__appliesTo,
	CORE__binary,
	CORE__connectionOptional,
	CORE__control,
	CORE__default,
	CORE__designation,
	CORE__documentation,
	CORE__enumeration,
	CORE__extensionData,
	CORE__freeWheeling,
	CORE__hardRTCapable,
	CORE__inPlaceBroken,
	CORE__index,
	CORE__integer,
	CORE__isLive,
	CORE__latency,
	CORE__maximum,
	CORE__microVersion,
	CORE__minimum,
	CORE__minorVersion,
	CORE__name,
	CORE__optionalFeature,
	CORE__port,
	CORE__portProperty,
	CORE__project,
	CORE__prototype,
	CORE__reportsLatency,
	CORE__requiredFeature,
	CORE__sampleRate,
	CORE__scalePoint,
	CORE__symbol,
	CORE__toggled,
	CORE__isBitmask,
	CORE__parameterProperty,

	DATA_ACCESS,

	DYN_MANIFEST,

	EVENT__Event,
	EVENT__EventPort,
	EVENT__FrameStamp,
	EVENT__TimeStamp,
	EVENT__generatesTimeStamp,
	EVENT__generic,
	EVENT__inheritsEvent,
	EVENT__inheritsTimeStamp,
	EVENT__supportsEvent,
	EVENT__supportsTimeStamp,

	INSTANCE_ACCESS,

	LOG__Entry,
	LOG__Error,
	LOG__Note,
	LOG__Trace,
	LOG__Warning,
	LOG__log,

	MIDI__ActiveSense,
	MIDI__Aftertouch,
	MIDI__Bender,
	MIDI__ChannelPressure,
	MIDI__Chunk,
	MIDI__Clock,
	MIDI__Continue,
	MIDI__Controller,
	MIDI__MidiEvent,
	MIDI__NoteOff,
	MIDI__NoteOn,
	MIDI__ProgramChange,
	MIDI__QuarterFrame,
	MIDI__Reset,
	MIDI__SongPosition,
	MIDI__SongSelect,
	MIDI__Start,
	MIDI__Stop,
	MIDI__SystemCommon,
	MIDI__SystemExclusive,
	MIDI__SystemMessage,
	MIDI__SystemRealtime,
	MIDI__Tick,
	MIDI__TuneRequest,
	MIDI__VoiceMessage,
	MIDI__benderValue,
	MIDI__binding,
	MIDI__byteNumber,
	MIDI__channel,
	MIDI__chunk,
	MIDI__controllerNumber,
	MIDI__controllerValue,
	MIDI__noteNumber,
	MIDI__pressure,
	MIDI__programNumber,
	MIDI__property,
	MIDI__songNumber,
	MIDI__songPosition,
	MIDI__status,
	MIDI__statusMask,
	MIDI__velocity,

	MORPH__AutoMorphPort,
	MORPH__MorphPort,
	MORPH__interface,
	MORPH__supportsType,
	MORPH__currentType,

	OPTIONS__Option,
	OPTIONS__interface,
	OPTIONS__options,
	OPTIONS__requiredOption,
	OPTIONS__supportedOption,

	PARAMETERS__CompressorControls,
	PARAMETERS__ControlGroup,
	PARAMETERS__EnvelopeControls,
	PARAMETERS__FilterControls,
	PARAMETERS__OscillatorControls,
	PARAMETERS__amplitude,
	PARAMETERS__attack,
	PARAMETERS__bypass,
	PARAMETERS__cutoffFrequency,
	PARAMETERS__decay,
	PARAMETERS__delay,
	PARAMETERS__dryLevel,
	PARAMETERS__frequency,
	PARAMETERS__gain,
	PARAMETERS__hold,
	PARAMETERS__pulseWidth,
	PARAMETERS__ratio,
	PARAMETERS__release,
	PARAMETERS__resonance,
	PARAMETERS__sampleRate,
	PARAMETERS__sustain,
	PARAMETERS__threshold,
	PARAMETERS__waveform,
	PARAMETERS__wetDryRatio,
	PARAMETERS__wetLevel,

	PATCH__Ack,
	PATCH__Delete,
	PATCH__Copy,
	PATCH__Error,
	PATCH__Get,
	PATCH__Message,
	PATCH__Move,
	PATCH__Patch,
	PATCH__Post,
	PATCH__Put,
	PATCH__Request,
	PATCH__Response,
	PATCH__Set,
	PATCH__Insert,
	PATCH__accept,
	PATCH__add,
	PATCH__body,
	PATCH__context,
	PATCH__destination,
	PATCH__property,
	PATCH__readable,
	PATCH__remove,
	PATCH__request,
	PATCH__subject,
	PATCH__sequenceNumber,
	PATCH__value,
	PATCH__wildcard,
	PATCH__writable,

	PORT_GROUPS__DiscreteGroup,
	PORT_GROUPS__Element,
	PORT_GROUPS__FivePointOneGroup,
	PORT_GROUPS__FivePointZeroGroup,
	PORT_GROUPS__FourPointZeroGroup,
	PORT_GROUPS__Group,
	PORT_GROUPS__InputGroup,
	PORT_GROUPS__MidSideGroup,
	PORT_GROUPS__MonoGroup,
	PORT_GROUPS__OutputGroup,
	PORT_GROUPS__SevenPointOneGroup,
	PORT_GROUPS__SevenPointOneWideGroup,
	PORT_GROUPS__SixPointOneGroup,
	PORT_GROUPS__StereoGroup,
	PORT_GROUPS__ThreePointZeroGroup,
	PORT_GROUPS__center,
	PORT_GROUPS__centerLeft,
	PORT_GROUPS__centerRight,
	PORT_GROUPS__element,
	PORT_GROUPS__group,
	PORT_GROUPS__left,
	PORT_GROUPS__lowFrequencyEffects,
	PORT_GROUPS__mainInput,
	PORT_GROUPS__mainOutput,
	PORT_GROUPS__rearCenter,
	PORT_GROUPS__rearLeft,
	PORT_GROUPS__rearRight,
	PORT_GROUPS__right,
	PORT_GROUPS__side,
	PORT_GROUPS__sideChainOf,
	PORT_GROUPS__sideLeft,
	PORT_GROUPS__sideRight,
	PORT_GROUPS__source,
	PORT_GROUPS__subGroupOf,

	PORT_PROPS__causesArtifacts,
	PORT_PROPS__continuousCV,
	PORT_PROPS__discreteCV,
	PORT_PROPS__displayPriority,
	PORT_PROPS__expensive,
	PORT_PROPS__hasStrictBounds,
	PORT_PROPS__logarithmic,
	PORT_PROPS__notAutomatic,
	PORT_PROPS__notOnGUI,
	PORT_PROPS__rangeSteps,
	PORT_PROPS__supportsStrictBounds,
	PORT_PROPS__trigger,

	//PRESETS__Bank,
	PRESETS__Preset,
	PRESETS__bank,
	//PRESETS__preset,
	PRESETS__value,

	RESIZE_PORT__asLargeAs,
	RESIZE_PORT__minimumSize,
	RESIZE_PORT__resize,

	//STATE__State,
	STATE__interface,
	STATE__loadDefaultState,
	STATE__freePath,
	STATE__makePath,
	STATE__mapPath,
	STATE__state,
	STATE__threadSafeRestore,
	STATE__StateChanged,

	TIME__Time,
	TIME__Position,
	TIME__Rate,
	TIME__position,
	TIME__barBeat,
	TIME__bar,
	TIME__beat,
	TIME__beatUnit,
	TIME__beatsPerBar,
	TIME__beatsPerMinute,
	TIME__frame,
	TIME__framesPerSecond,
	TIME__speed,

	UI__CocoaUI,
	UI__Gtk3UI,
	UI__GtkUI,
	UI__PortNotification,
	UI__PortProtocol,
	UI__Qt4UI,
	UI__Qt5UI,
	//UI__UI,
	UI__WindowsUI,
	UI__X11UI,
	UI__binary,
	UI__fixedSize,
	UI__idleInterface,
	UI__noUserResize,
	UI__notifyType,
	UI__parent,
	UI__plugin,
	UI__portIndex,
	UI__portMap,
	UI__portNotification,
	UI__portSubscribe,
	UI__protocol,
	UI__requestValue,
	UI__floatProtocol,
	UI__peakProtocol,
	UI__resize,
	UI__showInterface,
	UI__touch,
	UI__ui,
	UI__updateRate,
	UI__windowTitle,
	UI__scaleFactor,
	UI__foregroundColor,
	UI__backgroundColor,

	UNITS__Conversion,
	UNITS__Unit,
	UNITS__bar,
	UNITS__beat,
	UNITS__bpm,
	UNITS__cent,
	UNITS__cm,
	UNITS__coef,
	UNITS__conversion,
	UNITS__db,
	UNITS__degree,
	UNITS__frame,
	UNITS__hz,
	UNITS__inch,
	UNITS__khz,
	UNITS__km,
	UNITS__m,
	UNITS__mhz,
	UNITS__midiNote,
	UNITS__mile,
	UNITS__min,
	UNITS__mm,
	UNITS__ms,
	UNITS__name,
	UNITS__oct,
	UNITS__pc,
	UNITS__prefixConversion,
	UNITS__render,
	UNITS__s,
	UNITS__semitone12TET,
	UNITS__symbol,
	UNITS__unit,

	URID__map,
	URID__unmap,

	URI_MAP,

	WORKER__interface,
	WORKER__schedule,

	EXTERNAL_UI__Widget,

	INLINEDISPLAY__interface,
	INLINEDISPLAY__queue_draw,
	INLINEDISPLAY__surface,

	OSC__Message,
	OSC__messagePath,

	CVAS__graph,

	SYNTHPOD__state,
	SYNTHPOD__null,
	SYNTHPOD__payload,
	SYNTHPOD__graph,
	SYNTHPOD__stereo,
	SYNTHPOD__monoatom,
	SYNTHPOD__moduleList,
	SYNTHPOD__moduleSupported,
	SYNTHPOD__moduleAdd,
	SYNTHPOD__moduleDel,
	SYNTHPOD__moduleMove,
	SYNTHPOD__modulePresetLoad,
	SYNTHPOD__modulePresetSave,
	SYNTHPOD__moduleVisible,
	SYNTHPOD__moduleDisabled,
	SYNTHPOD__moduleProfiling,
	SYNTHPOD__modulePositionX,
	SYNTHPOD__modulePositionY,
	SYNTHPOD__moduleAlias,
	SYNTHPOD__moduleReinstantiate,
	SYNTHPOD__moduleCreated,
	SYNTHPOD__nodePositionX,
	SYNTHPOD__nodePositionY,
	SYNTHPOD__graphPositionX,
	SYNTHPOD__graphPositionY,
	SYNTHPOD__columnEnabled,
	SYNTHPOD__rowEnabled,
	SYNTHPOD__portRefresh,
	SYNTHPOD__bundleLoad,
	SYNTHPOD__bundleSave,
	SYNTHPOD__pathGet,
	SYNTHPOD__DSPProfiling,
	SYNTHPOD__CPUsAvailable,
	SYNTHPOD__CPUsUsed,
	SYNTHPOD__periodSize,
	SYNTHPOD__numPeriods,
	SYNTHPOD__quit,
	SYNTHPOD__systemPorts,
	SYNTHPOD__ControlPort,
	SYNTHPOD__AudioPort,
	SYNTHPOD__CVPort,
	SYNTHPOD__MIDIPort,
	SYNTHPOD__OSCPort,
	SYNTHPOD__ComPort,
	SYNTHPOD__connectionList,
	SYNTHPOD__nodeList,
	SYNTHPOD__subscriptionList,
	SYNTHPOD__notificationList,
	SYNTHPOD__automationList,
	SYNTHPOD__sourceModule,
	SYNTHPOD__sourceSymbol,
	SYNTHPOD__sinkModule,
	SYNTHPOD__sinkSymbol,
	SYNTHPOD__sourceMinimum,
	SYNTHPOD__sourceMaximum,
	SYNTHPOD__sinkMinimum,
	SYNTHPOD__sinkMaximum,
	SYNTHPOD__sourceEnabled,
	SYNTHPOD__sinkEnabled,
	SYNTHPOD__learning,
	SYNTHPOD__placeholder,
	SYNTHPOD__visibility,

	STAT_URID_MAX
} stat_urid_t;

extern const char *stat_uris [STAT_URID_MAX];

#endif
